package edu.travel.commodity.web;

import com.baomidou.mybatisplus.core.metadata.IPage;
import edu.travel.commodity.dto.BaseCountryDto;
import edu.travel.commodity.service.BaseCountryService;
import edu.travel.commodity.vo.BaseCountryVo;
import edu.travel.rpc.RPCBaseResponse;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

/**
 * 国家表(base_country)表控制层
 *
 * @author xxxxx
 */
@RestController
@RequestMapping("/base_country")
public class BaseCountryController {

    /**
     * 服务对象
     */
    @Autowired
    private BaseCountryService baseCountryService;


    //国家树
    @GetMapping("/getCountryTree")
    public RPCBaseResponse<List<BaseCountryVo>> getCountryTree() {
        return baseCountryService.getCountryTree();
    }

    //国家分页
    @GetMapping("/getCountryPage")
    public RPCBaseResponse<IPage<BaseCountryVo>> getCountryPage(BaseCountryDto baseCountryDTO) {
        return baseCountryService.getCountryPage(baseCountryDTO);
    }

}
